/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/*!
 * Next JS
 * Copyright (c)2011 Xenophy.CO.,LTD All rights Reserved.
 * http://www.xenophy.com
 */

// {{{ NX.util.Mime.types

module.exports = {
    ttf: 'application/octet-stream',
    woff: 'application/x-font-woff',
    dwg : 'application/acad',
    arj : 'application/arj',
    asd : 'application/astound',
    asn : 'application/astound',
    css : 'text/css',
    ccad : 'application/clariscad',
    drw : 'application/drafting',
    dxf : 'application/dxf',
    ico : 'image/vnd.microsoft.icon',
    unv : 'application/i-deas',
    iges : 'application/iges',
    iges : 'application/iges',
    jar : 'application/java-archive',
    hqx : 'application/mac-binhex40',
    mdb : 'application/msaccess',
    xla : 'application/msexcel',
    xls : 'application/msexcel',
    xlt : 'application/msexcel',
    xlw : 'application/msexcel',
    pot : 'application/mspowerpoint',
    pps : 'application/mspowerpoint',
    ppt : 'application/mspowerpoint',
    mpp : 'application/msproject',
    doc : 'application/msword',
    word : 'application/msword',
    w6w : 'application/msword',
    wri : 'application/mswrite',
    bin : 'application/octet-stream',
    oda : 'application/oda',
    pdf : 'application/pdf',
    ai : 'application/postscript',
    eps : 'application/postscript',
    ps : 'application/postscript',
    part : 'application/pro_eng',
    part : 'application/pro_eng',
    rtf : 'application/rtf',
    set : 'application/set',
    stl : 'application/sla',
    sol : 'application/solids',
    st : 'application/STEP',
    step : 'application/STEP',
    stp : 'application/STEP',
    vda : 'application/vda',
    bcpio : 'application/x-bcpio',
    cpio : 'application/x-cpio',
    csh : 'application/x-csh',
    dcr : 'application/x-director',
    dir : 'application/x-director',
    dxr : 'application/x-director',
    dvi : 'application/x-dvi',
    dwf : 'application/x-dwf',
    gtar : 'application/x-gtar',
    gz : 'application/x-gzip',
    gzip : 'application/x-gzip',
    hdf : 'application/x-hdf',
    js : 'application/x-javascript',
    latex : 'application/x-latex',
    bin : 'application/x-macbinary',
    mid : 'application/x-midi',
    mif : 'application/x-mif',
    cdf : 'application/x-netcdf',
    nc : 'application/x-netcdf',
    sh : 'application/x-sh',
    shar : 'application/x-shar',
    swf : 'application/x-shockwave-flash',
    sit : 'application/x-stuffit',
    sv4cpio : 'application/x-sv4cpio',
    sv4crc : 'application/x-sv4crc',
    tar : 'application/x-tar',
    tcl : 'application/x-tcl',
    tex : 'application/x-tex',
    texi : 'application/x-texinfo',
    texinfo : 'application/x-texinfo',
    roff : 'application/x-troff',
    t : 'application/x-troff',
    tr : 'application/x-troff',
    man : 'application/x-troff-man',
    me : 'application/x-troff-me',
    ms : 'application/x-troff-ms',
    ustar : 'application/x-ustar',
    src : 'application/x-wais-source',
    hlp : 'application/x-winhelp',
    zip : 'application/zip',
    au : 'audio/basic',
    snd : 'audio/basic',
    mid : 'audio/midi',
    midi : 'audio/midi',
    aif : 'audio/x-aiff',
    aifc : 'audio/x-aiff',
    aiff : 'audio/x-aiff',
    mp3 : 'audio/x-mpeg',
    ra : 'audio/x-pn-realaudio',
    ram : 'audio/x-pn-realaudio',
    rpm : 'audio/x-pn-realaudio-plugin',
    voc : 'audio/x-voice',
    wav : 'audio/x-wav',
    bmp : 'image/bmp',
    gif : 'image/gif',
    ief : 'image/ief',
    jpe : 'image/jpeg',
    jpeg : 'image/jpeg',
    jpg : 'image/jpeg',
    pict : 'image/pict',
    png : 'image/png',
    tif : 'image/tiff',
    tiff : 'image/tiff',
    ras : 'image/x-cmu-raster',
    pnm : 'image/x-portable-anymap',
    pbm : 'image/x-portable-bitmap',
    pgm : 'image/x-portable-graymap',
    ppm : 'image/x-portable-pixmap',
    rgb : 'image/x-rgb',
    xbm : 'image/x-xbitmap',
    xpm : 'image/x-xpixmap',
    xwd : 'image/x-xwindowdump',
    gzip : 'multipart/x-gzip',
    zip : 'multipart/x-zip',
    htm : 'text/html',
    html : 'text/html',
    C : 'text/plain',
    cc : 'text/plain',
    h : 'text/plain',
    txt : 'text/plain',
    rtx : 'text/richtext',
    tsv : 'text/tab-separated-values',
    etx : 'text/x-setext',
    sgm : 'text/x-sgml',
    sgml : 'text/x-sgml',
    mpe : 'video/mpeg',
    mpeg : 'video/mpeg',
    mpg : 'video/mpeg',
    avi : 'video/msvideo',
    mov : 'video/quicktime',
    qt : 'video/quicktime',
    vdo : 'video/vdo',
    viv : 'video/vivo',
    vivo : 'video/vivo',
    movie : 'video/x-sgi-movie',
    ice : 'x-conference/x-cooltalk',
    svr : 'x-world/x-svr',
    wrl : 'x-world/x-vrml',
    vrt : 'x-world/x-vrt',
    rdf : 'text/xml',
    xml : 'text/xml',
    json : 'application/json',
    docm : 'application/vnd.ms-word.document.macroEnabled.12',
    docx : 'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
    dotm : 'application/vnd.ms-word.template.macroEnabled.12',
    dotx : 'application/vnd.openxmlformats-officedocument.wordprocessingml.template',
    potm : 'application/vnd.ms-powerpoint.template.macroEnabled.12',
    potx : 'application/vnd.openxmlformats-officedocument.presentationml.template',
    ppam : 'application/vnd.ms-powerpoint.addin.macroEnabled.12',
    ppsm : 'application/vnd.ms-powerpoint.slideshow.macroEnabled.12',
    ppsx : 'application/vnd.openxmlformats-officedocument.presentationml.slideshow',
    pptm : 'application/vnd.ms-powerpoint.presentation.macroEnabled.12',
    pptx : 'application/vnd.openxmlformats-officedocument.presentationml.presentation',
    xlam : 'application/vnd.ms-excel.addin.macroEnabled.12',
    xlsb : 'application/vnd.ms-excel.sheet.binary.macroEnabled.12',
    xlsm : 'application/vnd.ms-excel.sheet.macroEnabled.12',
    xlsx : 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
    xltm : 'application/vnd.ms-excel.template.macroEnabled.12',
    xltx : 'application/vnd.openxmlformats-officedocument.spreadsheetml.template'
};

// }}}

/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * c-hanging-comment-ender-p: nil
 * End:
 */



